function FEMadm(action)

global g p e t w a1 a2 X Y u kxy gxy nbc
                             %g holds the geometry specification, 
                             %p(1,:) and p(2,:) hold the x- and 
                             %  y-coordinates of the nodal points,
                             %e holds edge type specification
                             %t(1:3,i) holds node numbers of triangle i
                             %w current mesh function
                             %a1 and a2 handles of the two axes
                             % X, Y hold the x,y coordinates of current bdry segm

cxy='x.*y';

  a1=findobj('Position',[0.1 0.5 0.6 0.35]);
  a2=findobj('Position',[0.1 0.1 0.6 0.35]);


switch action


case 'new domain'

  axes(a2)
  cla
  set(a2,'XLim',[-.1 1.1],'YLim',[-.1 1.1])
  title('domain')
  xlabel('x')
  ylabel('y')
  text(0,0,'','Tag','coords')
  g=[];
  kxy=[];
  gxy=[];
  nbc=0;
  FEMadm('new bdry segm')


case 'new bdry segm'

  set(findobj(gcbf,'Tag','x='),'Visible','on')
  set(findobj(gcbf,'Tag','x' ),'Visible','on')
  set(findobj(gcbf,'Tag','y='),'Visible','on')
  set(findobj(gcbf,'Tag','y' ),'Visible','on')
  set(findobj(gcbf,'Tag','ok'),'Visible','on')
  X=[]; Y=[];
  set(gcbf,'WindowButtonMotionFcn','FEMadm(''WBMF'')')
  set(gcbf,'WindowButtonDownFcn','FEMadm(''WBDF'')')


case 'WBDF'

  axes(a2)
  cp=get(a2,'CurrentPoint'); cp=cp(1,1:2);
  l=length(X);
  if round(l/2)==l/2
    x=[cp(1) cp(2)];
    y=[cp(2) cp(2)];
    if l>0
      x(1)=X(l);
      y(1)=Y(l);
    end
    X=[X x(1)];
    Y=[Y y(1)];
    line(x,y,'Tag','candidate','Color','r')
  else
    x=get(findobj(gcbf,'Tag','candidate'),'XData');
    y=get(findobj(gcbf,'Tag','candidate'),'YData');
    xy=[x(2) y(2)];
    XY=[X(1) Y(1)];
    if norm(XY-xy)<.1
      x(2)=X(1);
      y(2)=Y(1);
    end
    X=[X x(2)];
    Y=[Y y(2)];
    line('XData',x,'YData',y,'Tag','curve','Color','g')
    delete(findobj(gcbf,'Tag','candidate'));
  end
  FEMadm('closeup')
  
  
case 'WBMF'

  cp=get(a2,'CurrentPoint'); cp=cp(1,1:2);
  XLim=get(a2,'XLim');
  YLim=get(a2,'YLim');
  dX=XLim(2)-XLim(1);
  dY=YLim(2)-YLim(1);
  if XLim(1)<cp(1) & cp(1)<XLim(2) & YLim(1)<cp(2) & cp(2)<YLim(2)
    if cp(1)-XLim(1)<0.02*dX
      XLim(1)=XLim(1)-.05*dX;
    end
    if XLim(2)-cp(1)<0.02*dX
      XLim(2)=XLim(2)+.05*dX; 
    end
    if cp(2)-YLim(1)<0.02*dY
      YLim(1)=YLim(1)-.05*dY;
    end
    if YLim(2)-cp(2)<0.02*dY
      YLim(2)=YLim(2)+.05*dY;
    end
    set(a2,'XLim',XLim,'YLim',YLim)
    xy=['(' num2str(cp(1)) ',' num2str(cp(2)) ')'];
    set(findobj(gcbf,'Tag','coords'),'String',xy,'Position',cp)
  end
  if length(X)>0
    XY=[X(1) Y(1)];
    if norm(XY-cp)<0.1
      cp=XY;
    end
  end
  x=get(findobj(gcbf,'Tag','candidate'),'XData');
  y=get(findobj(gcbf,'Tag','candidate'),'YData');
  x(2)=cp(1);
  y(2)=cp(2);
  set(findobj(gcbf,'Tag','candidate'),...
       'XData',x,'YData',y)
 

case 'ok'

  nbc=nbc+1;
  h=findobj(gcbf,'Tag','curve');
  x=get(findobj(gcbf,'Tag','x'),'String');
  y=get(findobj(gcbf,'Tag','y'),'String');
  n=8;
  if length(x)>0 & length(y)>0
    l=length(X);
    s=0;
    X=[X eval(x)];
    Y=[Y eval(y)];
    for i=1:n-1
      s=i/n;
      X=[X eval(x) eval(x)];
      Y=[Y eval(y) eval(y)];
    end
    s=1;
    X=[X eval(x)];
    Y=[Y eval(y)];
    if l>0 & norm([X(l) Y(l)]-[X(l+1) Y(l+1)])<.1
      X(l)=X(l+1); Y(l)=Y(l+1);
    end
    ll=length(X);
    if norm([X(ll) Y(ll)]-[X(1) Y(1)])<.1
       X(1)=X(ll); Y(1)=Y(ll);
    end
    for j=1:n
      line([X(l+2*j-1) X(l+2*j)],[Y(l+2*j-1) Y(l+2*j)],'Tag','curve','Color','g','Userdata',nbc)
%      line([X(l+2*1-1:l+2*n)],[Y(l+2*1-1:l+2*n)],'Tag','curve','Color','g')
    end
    if l>0
       XData=get(h(1),'XData');
       YData=get(h(1),'YData');
       XData(2)=X(l+1);
       YData(2)=Y(l+1);
       set(h(1),'XData',XData,'YData',YData)
       if X(1)==X(ll)&Y(1)==Y(ll)
          XData=get(h(l/2),'XData');
          YData=get(h(l/2),'YData');
          XData(1)=X(1);
          YData(1)=Y(1);
          set(h(l/2),'XData',XData,'YData',YData)
       end
    end
  end
  XLim=get(gca,'XLim');
  YLim=get(gca,'YLim');
  set(gca,'XLim',[min(min(X),XLim(1)) max(max(X),XLim(2))],...
          'YLim',[min(min(Y),YLim(1)) max(max(Y),YLim(2))])
  axis('equal')
  FEMadm('closeup')


case 'closeup'

  l=length(X);
  if l>1 & X(l)==X(1) & Y(l)==Y(1)
    set(gcbf,'WindowButtonMotionFcn','')
    set(gcbf,'WindowButtonDownFcn','')
    set(findobj(gcbf,'Tag','coords'),'String','')
    set(findobj(gcbf,'Tag','x='),'Visible','off')
    set(findobj(gcbf,'Tag','x' ),'Visible','off')
    set(findobj(gcbf,'Tag','y='),'Visible','off')
    set(findobj(gcbf,'Tag','y' ),'Visible','off')
    set(findobj(gcbf,'Tag','ok'),'Visible','off')
  end


case 'modify'

  sp=get(a2,'CurrentPoint'); sp=sp(1,1:2);
  handle=[];
  for k=1:2
    index=0;
    dist=100;
    h=findobj(gcbf,'Tag','curve');
    for i=1:length(h)
      set(h(i),'Visible','on')
      X=get(h(i),'XData');
      Y=get(h(i),'YData');
      xy=[X(k) Y(k)];
      newdist=norm(xy-sp);
      if newdist<dist
        handle(k)=h(i);
        dist=newdist;
      end
    end
  end
  set(gcf,'Userdata',handle)
  if isempty(findobj(gcbf,'Tag','coords'))
    text(0,0,'','Tag','coords')
  end
  set(gcbf,'WindowButtonMotionFcn','FEMadm(''move'')')
  set(gcbf,'WindowButtonUpFcn','FEMadm(''stop'')')


case 'move'

  handle=get(gcf,'Userdata');
  cp=get(a2,'CurrentPoint'); cp=cp(1,1:2);
  xy=['(' num2str(cp(1)) ',' num2str(cp(2)) ')'];
  set(findobj(gcbf,'Tag','coords'),'String',xy,'Position',[cp 0],...
                       'Visible','on')
  for k=1:2
    X=get(handle(k),'XData');
    Y=get(handle(k),'YData');
    X(k)=cp(1);
    Y(k)=cp(2);
    set(handle(k),'XData',X,'YData',Y)
  end


case 'stop'

  set(gcbf,'WindowButtonMotionFcn','')
  set(gcbf,'WindowButtonUpFcn','')
  set(findobj(gcbf,'Tag','coords'),'Visible','off')


case 'mesh'

  set(findobj(gcbf,'Tag','coords'),'String','')
  set(findobj(gcbf,'Tag','x='),'Visible','off')
  set(findobj(gcbf,'Tag','x' ),'Visible','off')
  set(findobj(gcbf,'Tag','y='),'Visible','off')
  set(findobj(gcbf,'Tag','y' ),'Visible','off')
  set(findobj(gcbf,'Tag','ok'),'Visible','off')
  g=[];
  h=findobj(gcbf,'Tag','curve');
  for i=1:length(h)
    X=get(h(i),'XData');
    XX(i,:)=X;
    Y=get(h(i),'YData');
    YY(i,:)=Y;
    l=length(X);
    dg=[X(1:2:l);X(2:2:l);Y(1:2:l);Y(2:2:l)];
    e=ones(size(X(2:2:l)));
    dg=[2*e;dg;e;0*e];
    g=[g dg];
  end
  if isempty(h)
    set(findobj(gcbf,'Tag','curveint'),...
           'String','define boudary','Visible','on')
    pause(2)
    set(findobj(gcbf,'Tag','curveint'),'Visible','off')
  end
  [p,e,t]=initmesh(g,'Hmax',.4);
  axes(a2)
  XLim=get(a2,'XLim');
  YLim=get(a2,'YLim');
  pdesurf(p,t,zeros(size(p(1,:)))')
  title('domain')
  xlabel('x')
  ylabel('y')
  hold on
  pdemesh(p,e,t)
  for i=1:length(XX)
    line(XX(i,:),YY(i,:),'Tag','curve','Color','g',...
            'Visible','off');
  end
  hold off
  set(a2,'XLim',XLim,'YLim',YLim)
  view(2)


case 'refine'

  axes(a2)
  h=findobj(gcbf,'Tag','curve');
  for i=1:length(h)
    XX(i,:)=get(h(i),'XData');
    YY(i,:)=get(h(i),'YData');
  end
  XLim=get(a2,'XLim');
  YLim=get(a2,'YLim');
  [p,e,t]=refinemesh(g,p,e,t);
  pdesurf(p,t,zeros(size(p(1,:)))')
  title('domain')
  xlabel('x')
  ylabel('y')
  view(2)
  hold on
  pdemesh(p,e,t)
  for i=1:length(XX)
    line(XX(i,:),YY(i,:),'Tag','curve','Color','g',...
            'Visible','off');
  end
  hold off
  set(a2,'XLim',XLim,'YLim',YLim)


case 'apply'

  set(gcbf,'WindowButtonDownFcn','FEMadm(''mark bdry'')')


case 'mark bdry'

  sp=get(a2,'CurrentPoint'); sp=sp(1,1:2);
  axes(a2)
  XLim=get(a2,'XLim');
  YLim=get(a2,'YLim');
  if XLim(1)<sp(1)&sp(1)<XLim(2)&YLim(1)<sp(2)&sp(2)<YLim(2)
    index=0;
    dist=100;
    h=findobj(gcbf,'Tag','curve');
    handle=[];
    for i=1:length(h)
      X=get(h(i),'XData');
      Y=get(h(i),'YData');
       xy=[X(1)+X(2) Y(1)+Y(2)]/2;
       newdist=norm(xy-sp);
%newdist=1000;
%for i=1:length(X)-1
%xy=[X(i)+X(i+1) Y(i)+Y(i+1)]/2;
%newdist=min(newdist,norm(xy-sp));
%end
      if newdist<dist
        handle=h(i);
        index=i;
        dist=newdist;
      end
    end
%index
%handle=h(index);
%ud=get(handle,'Userdata')
%for i=1:length(h)
%  udx=get(h(i),'Userdata')
%  if udx==ud
%    index=[index i]
%  end
%end 
    k=get(findobj(gcbf,'Tag','k'),'String');
    gxyi=get(findobj(gcbf,'Tag','g'),'String');
%    set(handle,'Userdata',{k g})
    kxy{index}=k;
    gxy{index}=gxyi;
    set(handle,'Linewidth',2,'Visible','on')
  else
    set(gcbf,'WindowButtonDownFcn','')
  end




case 'solve'

  axy=get(findobj(gcbf,'Tag','a'),'String');
  fxy=get(findobj(gcbf,'Tag','f'),'String');
  for i=1:length(findobj(gcbf,'Tag','curve'))
    if isempty(kxy{i})|isempty(gxy{i})
      disp('bdry condition lacking on bdry i')
      return
    end
  end
  A=stiff(p,t,e,axy,cxy,kxy);
  A=sparse(A);
  b=loads(p,t,e,fxy,kxy,gxy);
  u=A\b;
  axes(a1)
  s=0:0.02:1;
  C=[(s.^2)' (1-s)'.*s' (1-s.^2)'];
  colormap(C);
  XLim=get(a2,'XLim');
  YLim=get(a2,'YLim');
  pdesurf(p,t,u)
  hold on
  pdeplot(p,e,t,'zdata',u,'mesh','on')
  hold off
  set(a1,'XLim',XLim,'YLim',YLim)
  w=u;
  FEMadm('add plotvalue')


case 'add plotvalue'

  axes(a1)
  ZLim=get(a1,'ZLim');
  hold on
  W=min(0,ZLim(1))*ones(size(w));
  pdesurf(p,t,W)
  hold off
  if get(gcf,'CurrentObject')==findobj(gcbf,'Tag','solve')
    tit='solution  u(x,y)';
  else
    tit='residual   f - div (a grad u)';
  end
  hold on
  pdeplot(p,e,t,'zdata',W,'mesh','on','title',tit)
  hold off
  grid on
  rotate3d on


case 'cont+flux'

  h=findobj(gcbf,'Tag','curve');
  for i=1:length(h)
    XX(i,:)=get(h(i),'XData');
    YY(i,:)=get(h(i),'YData');
  end
  XLim=get(a2,'XLim');
  YLim=get(a2,'YLim');
  axes(a2)
  cla
  tit='';
  c_value=get(findobj(gcbf,'Tag','contours'),'Value');
  if c_value==1
%    pdecont(p,t,w')
    pdecont(p,t,u')
    tit='contours';
  end
  f_value=get(findobj(gcbf,'Tag','gradients'),'Value');
  if f_value==1
    axy=get(findobj(gcbf,'Tag','a'),'String');
%    [wx,wy]=pdegrad(p,t,w);
    [wx,wy]=pdegrad(p,t,u);
    x=(p(1,t(1,:))+p(1,t(2,:))+p(1,t(3,:)))/3;
    y=(p(2,t(1,:))+p(2,t(2,:))+p(2,t(3,:)))/3;
    a=eval(axy);
    hold on
    quiver(x,y,-a.*wx,-a.*wy)
    hold off
    if isempty(tit)
      tit=[tit 'flux'];
    else
      tit=[tit ' & flux'];
    end
  end
  if isempty(tit)
    tit='domain';
  end
  title(tit)
  set(a2,'XLim',XLim,'YLim',YLim)
  for i=1:length(XX)
    line(XX(i,:),YY(i,:),'Tag','curve','Color','g')
  end
  

case 'residual'

  [ux,uy]=pdegrad(p,t,u);
  x=(p(1,t(1,:))+p(1,t(2,:))+p(1,t(3,:)))/3;
  y=(p(2,t(1,:))+p(2,t(2,:))+p(2,t(3,:)))/3;
  axy=get(findobj(gcbf,'Tag','a'),'String');
  fxy=get(findobj(gcbf,'Tag','f'),'String');
  a=eval(axy).*ones(size(x));
  f=eval(fxy).*ones(size(x));
  ux=a.*ux;
  uy=a.*uy;
  ux=pdeprtni(p,t,ux);
  uy=pdeprtni(p,t,uy);
  [uxx,uxy]=pdegrad(p,t,ux);
  [uxy,uyy]=pdegrad(p,t,uy);
  div_a_grad_u=uxx+uyy;
  res=f+div_a_grad_u;
  res=pdeprtni(p,t,res);
  axes(a1)
  pdesurf(p,t,res)
  hold on
  pdeplot(p,e,t,'zdata',res,'mesh','on')
  hold off
  XLim=get(a2,'XLim');
  YLim=get(a2,'YLim');
  set(a1,'XLim',XLim,'YLim',YLim)
  w=res;
  FEMadm('add plotvalue')
    


end




function dw=diffq(x,y,wxy,h,k)

  w=eval(wxy);
  x=x+h;
  y=y+k;
  dw=(eval(wxy)-w)/sqrt(h^2+k^2);


function int=sumup(X,Y,a,b,ds)

  uxy=get(findobj(gcbf,'Tag','u'),'String');
  vxy=get(findobj(gcbf,'Tag','v'),'String');
  dx=diff(X);
  dy=diff(Y);
  int=0;
  z=(0:10)/10;
  for i=1:length(ds)
    x=X(i)+dx(i)*z;
    y=Y(i)+dy(i)*z;
    u=eval(uxy);
    v=eval(vxy);
    u=(sum(u(1:10))+sum(u(2:11)))/20;
    v=(sum(v(1:10))+sum(v(2:11)))/20;
    int=int+(u*a(i)+v*b(i))*ds(i);
    patch([X(i) X(i)+dx(i) X(i)+dx(i) X(i)],...
          [Y(i) Y(i)+dy(i) Y(i)+dy(i) Y(i)],...
          [0 0 1 1])
  end


function [ux,uy,vx,vy]=getduv(p,h)

  [uxy,vxy]=getuv(0);
  [x,y]=getxy(p);
  ux=diffq(x,y,uxy,h,0);
  vx=diffq(x,y,vxy,h,0);
  uy=diffq(x,y,uxy,0,h);
  vy=diffq(x,y,vxy,0,h);


function [uxy,vxy]=getuv(dummy)

  uxy=get(findobj(gcbf,'Tag','u'),'String');
  vxy=get(findobj(gcbf,'Tag','v'),'String');


function [x,y]=getxy(p)

  x=p(1,:);
  y=p(2,:);


function A=stiff(p,t,e,axy,cxy,kxy)

  A=zeros(length(p(1,:)),length(p(1,:)));
%  kol=[];row=[];entry=[];
  for i=1:length(t(1,:))
    x=p(1,t(1:3,i));
    y=p(2,t(1:3,i));
    ar=area(x,y);
    g=grad(x,y);
    x=sum(x)/3;
    y=sum(y)/3;
    a=eval(axy);
    c=eval(cxy);
%    row=[row t(1:3,i)' t(1:3,i)' t(1:3,i)'];
%    kol=[kol t(1,i)*[1 1 1] t(2,i)*[1 1 1] t(3,i)*[1 1 1]];
%    entry=[entry ar*a*g(1:2,1)'*g ar*a*g(1:2,2)'*g ar*a*g(1:2,3)'*g];
    A(t(1:3,i),t(1:3,i))=A(t(1:3,i),t(1:3,i))+ar*a*g'*g;
  end
  for i=1:length(e(1,:))
    x=p(1,e(1:2,i));
    y=p(2,e(1:2,i));
    xy=[x;y];
    edge=e(5,i);
    kxyi=kxy{edge};
    k=eval(kxyi).*ones(size(x));
%    row=[row e(1:2,i)' e(1:2,i)'];
%    kol=[kol e(1,i)*[1 1] e(2,i)*[1 1]];
%    entry=[entry ar*[k(1)/3 (k(1)+k(2))/12 (k(1)+k(2))/12 k(2)/3]];
    ar=norm(xy(:,1)-xy(:,2));
    A(e(1:2,i),e(1:2,i))=A(e(1:2,i),e(1:2,i))...
              +ar*[k(1)/3 (k(1)+k(2))/12;(k(1)+k(2))/12 k(2)/3];
  end
%    A=sparse(row,kol,entry);


function b=loads(p,t,e,fxy,kxy,gxy)

  b=zeros(length(p(1,:)),1);
  for i=1:length(t(1,:))
    x=p(1,t(1:3,i));
    y=p(2,t(1:3,i));
    f=eval(fxy).*ones(size(x));
    ar=area(x,y);
    b(t(1:3,i))=b(t(1:3,i))+ar*f'/3;
  end
  for i=1:length(e(1,:))
    x=p(1,e(1:2,i));
    y=p(2,e(1:2,i));
    xy=[x;y];
    edge=e(5,i);
    kxyi=kxy{edge};
    gxyi=gxy{edge};
    k=eval(kxyi).*ones(size(x));
    g=eval(gxyi).*ones(size(x));
    ar=norm(xy(:,1)-xy(:,2));
    b(e(1:2,i))=b(e(1:2,i))+ar*[k(1)*g(1)/2;k(2)*g(2)/2];
  end


function ar=area(x,y)

  ar=(x(2)-x(1))*(y(3)-y(1))-(x(3)-x(1))*(y(2)-y(1));
  ar=ar/2;


function g=grad(x,y)

  xy=[x;y];
  v=xy(:,3)-xy(:,1);
  w=xy(:,2)-xy(:,1);
  proj=dot(v,w)*w/norm(w)^2;
  gr=v-proj;
  g=gr/norm(gr)^2;
  proj=dot(w,v)*v/norm(v)^2;
  gr=w-proj;
  g=[g gr/norm(gr)^2];
  g=[-sum(g')' g]; 
