function Pen_adm(action)

global x y halt cp

switch action


case 'length slided'

  k=get(findobj(gcbf,'Tag','length_slider'),'Value');
  set(findobj(gcbf,'Tag','length'),'String',num2str(k,'%1.2f'))


case 'length given'

  k=eval(get(findobj(gcbf,'Tag','length'),'String'));
  set(findobj(gcbf,'Tag','length_slider'),'Value',k)


case 'mass slided'

  k=get(findobj(gcbf,'Tag','mass_slider'),'Value');
  set(findobj(gcbf,'Tag','mass'),'String',num2str(k,'%1.2f'))


case 'mass given'

  k=eval(get(findobj(gcbf,'Tag','mass'),'String'));
  set(findobj(gcbf,'Tag','mass_slider'),'Value',k)


case 'damping slided'

  k=get(findobj(gcbf,'Tag','damping_slider'),'Value');
  set(findobj(gcbf,'Tag','damping'),'String',num2str(k,'%1.2f'))


case 'damping given'

  k=eval(get(findobj(gcbf,'Tag','damping'),'String'));
  set(findobj(gcbf,'Tag','damping_slider'),'Value',k)


case 'timestep slided'

  k=get(findobj(gcbf,'Tag','timestep_slider'),'Value');
  set(findobj(gcbf,'Tag','timestep'),'String',num2str(k,'%1.3f'))


case 'timestep given'

  k=eval(get(findobj(gcbf,'Tag','timestep'),'String'));
  set(findobj(gcbf,'Tag','timestep_slider'),'Value',k)


case 'start'

  halt='yes';
  set(gcbf,'WindowButtonMotionFcn','Pen_adm(''move'')')
  set(gcbf,'WindowButtonUpFcn','Pen_adm(''stop'')')


case 'move'
   
  set(gcf,'DoubleBuffer','on')	
  cp=get(findobj(gcbf,'Tag','Axes1'),'CurrentPoint');
  cp=cp(1,1:2);
  xold=x;
  if cp(2)<=0
    x=atan(-cp(1)/cp(2));
  else
    x=pi+atan(-cp(1)/cp(2));
  end
  y=50*(x-xold);
  Pen_adm('plot')


case 'stop'

  set(gcbf,'WindowButtonMotionFcn','')
  set(gcbf,'WindowButtonUpFcn','')
  halt='no ';
  Pen_adm('compute')


case 'compute'
   
  set(gcf,'DoubleBuffer','on')					%Tar bort flimmret 
  models=get(findobj(gcbf,'Tag','model'),'String');
  choice=get(findobj(gcbf,'Tag','model'),'Value');
  model=models{choice};
	th=findobj(gcbf,'Tag','Axes1Text1');
  if model=='linearized'
    set(th,'String','ml\phi^{\prime\prime}=-mg\phi-dl\phi^\prime');
  elseif model=='non-linear'
    set(th,'String','ml\phi^{\prime\prime}=-mgsin(\phi)-dl\phi^\prime');
  end
  set(th,'FontSize',14)
  set(findobj(gcbf,'Tag','Axes2Text4'),'String','time')

  methods=get(findobj(gcbf,'Tag','method'),'String');
  choice=get(findobj(gcbf,'Tag','method'),'Value');
  method=methods{choice};

  g=9.81;
  l=eval(get(findobj(gcbf,'Tag','length'),'String'));
  max_x=sqrt(l/g*y^2+x^2);
  if method=='Euler '
    set(findobj(gcbf,'Tag','Axes2'),'YLim',[-2*max_x 2*max_x])
  else
    set(findobj(gcbf,'Tag','Axes2'),'YLim',[-1.1*max_x 1.1*max_x])
  end

  for i=1:500

    l=eval(get(findobj(gcbf,'Tag','length'),'String'));
    m=eval(get(findobj(gcbf,'Tag','mass'),'String')); 
    d=eval(get(findobj(gcbf,'Tag','damping'),'String'));
    k=eval(get(findobj(gcbf,'Tag','timestep'),'String'));

    if halt=='yes'
      break
    end

    if model=='linearized'
      fx='Y';
      fy='-g/l*X-d/m*Y';
      df='[0 1;-g/l -d/m]';
    end

    if model=='non-linear'
      fx='Y';
      fy='-g/l*sin(X)-d/m*Y';
      df='[0 1;-g/l*cos(X) -d/m]';
    end

    xold=x;
    yold=y;
    X=xold;
    Y=yold;

    if method=='Euler '
      XY(1)=xold+k*eval(fx);
      XY(2)=yold+k*eval(fy);
      X=XY(1);
      Y=XY(2);
    end

    if method=='dG0   '
      res=[1;1];
      while norm(res)>0.001
        res=[X-k*eval(fx)-xold;Y-k*eval(fy)-yold];
        matrix=eye(2)-k*eval(df);
        XY=[X;Y]-matrix\res;
        X=XY(1);
        Y=XY(2);
      end
    end

    if method=='cG1   '
      fxold=eval(fx);
      fyold=eval(fy);
      res=[1;1];
      while norm(res)>0.001
        res=[X-k/2*eval(fx)-xold-k/2*fxold;Y-k/2*eval(fy)-yold-k/2*fyold];
        matrix=eye(2)-k/2*eval(df);
        XY=[X;Y]-matrix\res;
        X=XY(1);
        Y=XY(2);
      end
    end

    x=X;
    y=Y;

    Pen_adm('plot')
    drawnow

  end


case 'plot'

  l=eval(get(findobj(gcbf,'Tag','length'),'String'));
  x_c=0.05*l*cos((1:10)/10*2*pi);
  y_c=0.05*l*sin((1:10)/10*2*pi);
  p_XData=[0 l*sin(x) l*sin(x)+x_c];
  p_YData=[0 -l*cos(x) -l*cos(x)+y_c];
  set(findobj(gcbf,'Tag','pendulum'),'XData',p_XData,'YData',p_YData)
  set(findobj(gcbf,'Tag','Axes1'),'XLim',[-1.1*l 1.1*l],'YLim',[-1.1*l 1.1*l])
  if halt=='yes'
    XData=0;
    YData=x;
  else
    XData=get(findobj(gcbf,'Tag','angle'),'XData');
    YData=get(findobj(gcbf,'Tag','angle'),'YData');
    k=eval(get(findobj(gcbf,'Tag','timestep'),'String'));
    XData=[XData XData(length(XData))+k];
    YData=[YData x];
  end
  if XData(length(XData))-XData(1)>5
    XData=XData(2:length(XData));
    YData=YData(2:length(YData));
  end
  set(findobj(gcbf,'Tag','angle'),'XData',XData,'YData',YData)
  set(findobj(gcbf,'Tag','Axes2'),'XLim',[min(XData) min(XData)+5])
  YLim=get(findobj(gcbf,'Tag','Axes2'),'YLim');
  if max(YData)>YLim(2)|min(YData)<YLim(1)
    YLim=[min(YData)-.1 max(YData)+.1];
    set(findobj(gcbf,'Tag','Axes2'),'YLim',YLim)
  end
%         [-max(2*abs(YData(1)),-min(YData)) max(2*abs(YData(1)),max(YData))]);


case 'halt'
   halt='yes';
   end
