function Taymod(action)

global select_point


switch action


case 'create'
  set(findobj(1,'Tag','taylor_pol'),'TooltipString','Taylor polynomial')
  delete(findobj(gcbf,'Tag','polynomial'));
  d=get(findobj(gcbf,'Tag','degree'),'Value');   %d=degree+1
  a=eval(get(findobj(gcbf,'Tag','a'),'String'));
  z=get(findobj(gcbf,'Tag','plot_win'),'Userdata');
  x=a-z:2*z/100:a+z;
  y=zeros(size(x));
  for j=1:d
    c(j)=-1+2*rand(1);
    y=y+c(j)*(x-a).^(j-1);
  end
  set(findobj(gcbf,'Tag','f(a)'),'Value',2/pi*atan(c(1)));
  if d>1
    set(findobj(gcbf,'Tag','Df(a)'),'Value',2/pi*atan(c(2)));
  end
  if d>2
    set(findobj(gcbf,'Tag','DDf(a)'),'Value',2/pi*atan(c(3)));
  end
  line(x,y,'Tag','polynomial','Userdata',c);

  px(c,a)


case 'start'

  select_point=get(gca,'CurrentPoint');
  set(findobj(gcbf,'Tag','Fig1'),'Userdata',select_point)
  mod_type=get(findobj(gcbf,'Tag','mod_type'),'Value');
  if mod_type==2
    set(gcbf, 'WindowButtonMotionFcn',...
              'Taymod(''stop'')');
  elseif mod_type==1
    line([0 0],[0 0],'Color','g','LineStyle','-.','Tag','temp_line')
    set(gcbf, 'WindowButtonMotionFcn',...
              'Taymod(''move_a'')');
  end
  set(gcbf, 'WindowButtonUpFcn',     'Taymod(''stop'')');


case 'change'

  Taymod('plot_fcn')
  YLim=get(gca,'YLim');

  d=get(findobj(gcbf,'Tag','degree'),'Value');
  a=eval(get(findobj(gcbf,'Tag','a'),'String'));
  z=get(findobj(gcbf,'Tag','plot_win'),'Userdata');
  c=get(findobj(gcbf,'Tag','polynomial'),'Userdata');
  c(1)=tan(pi/2*get(findobj(gcbf,'Tag','f(a)'),'Value'));
  c(2)=tan(pi/2*get(findobj(gcbf,'Tag','Df(a)'),'Value'));
  c(3)=tan(pi/2*get(findobj(gcbf,'Tag','DDf(a)'),'Value'));
  x=a-z:2*z/100:a+z;
  y=zeros(size(x));
  for j=1:d
    y=y+c(j)*(x-a).^(j-1);
  end
  set(findobj(gcbf,'Tag','polynomial'),'XData',x,'YData',y,'Userdata',c)
  axis([x(1) x(length(x)) YLim(1) YLim(2)]);
  px(c,a)
  drawnow

  f=get(findobj(gcbf,'Tag','my_fcn'),'String');
  if isempty(f)==0
    Taymod('comp_error')
  end


case 'stop'

  set(gcbf, 'WindowButtonMotionFcn', '');
  set(gcbf, 'WindowButtonUpFcn', '');
  delete(findobj(gcbf,'Tag','temp_line'))
  Taymod('comp_error')


case 'zoom in'
  
  z=get(findobj(gcbf,'Tag','plot_win'),'Userdata');
  set(findobj(gcbf,'Tag','plot_win'),'Userdata',z/2);
  Taymod('change')


case 'zoom out'
  
  z=get(findobj(gcbf,'Tag','plot_win'),'Userdata');
  set(findobj(gcbf,'Tag','plot_win'),'Userdata',z*2);
  Taymod('change')


case 'choose_fcn'

  value=get(findobj(gcbf,'Tag','f_gallery'),'Value');
  string=get(findobj(gcbf,'Tag','f_gallery'),'String');
  f=string{value};

  set(findobj(gcbf,'Tag','my_fcn'),'String',f)
  Taymod('plot_fcn')


case 'plot_fcn'

  delete(findobj(gcbf,'Tag','f_graph'))
  title('')

  f=get(findobj(gcbf,'Tag','my_fcn'),'String');
  if isempty(f)
%    disp('nothing to plot')
  else
    a=eval(get(findobj(gcbf,'Tag','a'),'String'));
    z=get(findobj(gcbf,'Tag','plot_win'),'Userdata');
    f=get(findobj(gcbf,'Tag','my_fcn'),'String');
    x=a-z:2*z/100:a+z;
    y=eval(f);
    line(x,eval(f),'Color','r','Tag','f_graph')
    %title(['f(x) = ' f],'FontSize',11)
    axis([x(1) x(length(x)) min(y)-.5 max(y)+.5]);
  end


case 'taylor'

  f=get(findobj(gcbf,'Tag','my_fcn'),'String');
  if isempty(f)
    disp('nothing to interpolate')
  else
%    disp('interpolating')
poly=findobj(gcbf,'Tag','polynomial');
if isempty(poly)
   set(findobj(1,'Tag','taylor_pol'),'TooltipString','Create polynomial first')
   disp('Create polynomial first')
   break
end

d=get(findobj(gcbf,'Tag','degree'),'Value');
    a=eval(get(findobj(gcbf,'Tag','a'),'String'));
    
    dx=0.001;
    for j=1:d
      x=a-(j-1)*dx/2:dx:a+(j-1)*dx/2;
      fx=eval(f);
      for k=1:j-1
        fx=diff(fx)/dx/k;
      end
      c(j)=fx;
    end

    set(findobj(gcbf,'Tag','polynomial'),'Userdata',c);
    set(findobj(gcbf,'Tag','f(a)'),'Value',2/pi*atan(c(1)));
    set(findobj(gcbf,'Tag','Df(a)'),'Value',0);
    set(findobj(gcbf,'Tag','Df(a)'),'Value',0);
    if d>1
      set(findobj(gcbf,'Tag','Df(a)'),'Value',2/pi*atan(c(2)));
    end
    if d>2
      set(findobj(gcbf,'Tag','DDf(a)'),'Value',2/pi*atan(c(3)));
    end

    Taymod('change')

    Taymod('comp_error')

  end


case 'taylor_movie'

  f=get(findobj(gcbf,'Tag','my_fcn'),'String');
  if isempty(f)    disp('nothing to interpolate')
  else
    disp('interpolating')
    d=get(findobj(gcbf,'Tag','degree'),'Value');
    a=eval(get(findobj(gcbf,'Tag','a'),'String'));
    
    dx=0.001;
    for j=1:d
      x=a-(j-1)*dx/2:dx:a+(j-1)*dx/2;
      fx=eval(f);
      for k=1:j-1
        fx=diff(fx)/dx/k;
      end
      c(j)=fx;
    end

    c_target=c;
    c=0*c;
    for j=1:d
      for step=0:c_target(j)/10:c_target(j)
        c(j)=step;

        set(findobj(gcbf,'Tag','polynomial'),'Userdata',c);
        set(findobj(gcbf,'Tag','f(a)'),'Value',2/pi*atan(c(1)));
        set(findobj(gcbf,'Tag','Df(a)'),'Value',0);
        set(findobj(gcbf,'Tag','Df(a)'),'Value',0);
        if d>1
          set(findobj(gcbf,'Tag','Df(a)'),'Value',2/pi*atan(c(2)));
        end
        if d>2
          set(findobj(gcbf,'Tag','DDf(a)'),'Value',2/pi*atan(c(3)));
        end

        Taymod('change')

      end
      Taymod('comp_error')
      pause(1)
    end
  end


case 'move_a'

  sp=get(findobj(gcbf,'Tag','Fig1'),'Userdata');
  old_a=sp(1,1);
  pos=get(gca,'CurrentPoint');
  a=pos(1,1);
  a=old_a+0.6*(a-old_a);
  set(findobj(gcbf,'Tag','a'),'String',num2str(a))
  Taymod('taylor')
  YData=get(findobj(gcbf,'Tag','polynomial'),'YData');
  y=YData(51);
%  set(findobj(gcbf,'Tag','temp_line'),'XData',[a a],'YData',[0 y])


case 'comp_error'

  y=get(findobj(gcbf,'Tag','f_graph'),'YData');
  Y=get(findobj(gcbf,'Tag','polynomial'),'YData');
  error=max(abs(y-Y));
  set(findobj(gcbf,'Tag','err'),'String',['max error = ' num2str(error)])


case 'reset'

  set(findobj(gcbf,'Tag','my_fcn'),'String','')
  set(findobj(gcbf,'Tag','f_gallery'),'Value',1)
  set(findobj(gcbf,'Tag','a'),'String',num2str(0))
  set(findobj(gcbf,'Tag','a_slider'),'Value',0)
  set(findobj(gcbf,'Tag','degree'),'Value',3)
  set(findobj(gcbf,'Tag','plot_win'),'Userdata',1)
  title('')
  set(findobj(gcbf,'Tag','f(a)'),'Value',0)
  set(findobj(gcbf,'Tag','Df(a)'),'Value',0)
  set(findobj(gcbf,'Tag','DDf(a)'),'Value',0)
  set(findobj(gcbf,'Tag','err'),'String','max error')
  set(findobj(1,'Tag','taylor_pol'),'TooltipString','Create polynomial first')

end


function px(c,a)
  
  d=get(findobj(gcbf,'Tag','degree'),'Value');
  text='p(x) = ';
  if c(1)~=0
    text=[text num2str(c(1),'%1.1f')];
  end
  for j=2:min(d,4)
    if c(j)>0
      text=[text ' + '];
    else
      text=[text ' '];
    end
    if c(j)>0|c(j)<0
      text=[text num2str(c(j),'%1.1f')];
      if a>0
        text=[text ' (x - ' num2str(a,'%1.1f') ')'];
      elseif a<0
        text=[text ' (x + ' num2str(-a,'%1.1f') ')'];
      else
        text=[text ' x'];
      end
      if j>2
        text=[text '^' num2str(j-1)];
      end
    end
  end
  if d>4&c(5)~=0
    text=[text ' + ...'];
  end
  title(text)
